# Publications

STACK is a very popular online assessment system, used by many groups in a variety of languages.  STACK has been the subject of research, and has itself enabled research projects to take place. This page contains a selection of publications.  

### Publicity materials.

We have a booklet of [case studies](../../content/2019-cate-case-studies.pdf), and a PDF flyer about the [STACK project](../../content/2018-STACK.pdf).

We have a "Getting started with STACK" [guide](../../content/2019-STACK-Guide.pdf) ([Spanish](../../content/es/2019-STACK-Guide.pdf)).

### Computer aided assessment of mathematics

![Cover of Computer Aided Assessment of Mathematics](../../content/CAACover.jpg)  

[Computer Aided Assessment of Mathematics](http://ukcatalogue.oup.com/product/9780199660353.do#.UklVZtKSJuc), Chris Sangwin, Oxford University Press, 2013.

This book provides an Introduction to Computer Aided Assessment using STACK as the main working example.

### Nakamura (2010)

![Cover](../../content/NakamuraCover.jpg)

Y. Nakamura, [The STACK e-Learning and Assessment System for mathematics, science and engineering education through Moodle](http://books.rakuten.co.jp/rb/%E6%95%B0%E5%AD%A6e%E3%83%A9%E3%83%BC%E3%83%8B%E3%83%B3%E3%82%B0-%E6%95%B0%E5%BC%8F%E8%A7%A3%E7%AD%94%E8%A9%95%E4%BE%A1%E3%82%B7%E3%82%B9%E3%83%86%E3%83%A0%EF%BC%B3%EF%BC%B4%EF%BC%A1%EF%BC%A3%EF%BC%AB%E3%81%A8%EF%BC%AD%EF%BD%8F%EF%BD%8F%EF%BD%84%EF%BD%8C%EF%BD%85%E3%81%AB%E3%82%88%E3%82%8B-%E4%B8%AD%E6%9D%91%E6%B3%B0%E4%B9%8B-9784501548209/item/6640557/), Tokyo Denki University Press, 2010, (In Japanese) ISBN 978-4-501-54820-9.

## Papers about STACK

Proceedings of the 1st International STACK Conference can be found can be found on the open access publication server Zenodo here: [https://zenodo.org/communities/stack](https://zenodo.org/communities/stack)

A comprehensive bibliography is available here: [STACK bibliography](../../content/stack_publications.pdf), with the entries in [BiBTeX format](../../content/stack.bib).

These two recent papers about STACK are a good place to start:

* C. J. Sangwin and N. Kocher. [Automation of mathematics examinations](https://www.research.ed.ac.uk/portal/files/22213256/2015_11_9_AutomationExaminations.pdf). Computers and Education, 94:215-227, 2016.
* C. J. Sangwin and I. Jones. [Asymmetry in student achievement on multiple choice and constructed response items in reversible mathematics processes](https://dspace.lboro.ac.uk/dspace-jspui/handle/2134/22120). Educational Studies in Mathematics, 94:205-222, 2017.


