# Developers

The Developer documentations give information on STACK development, as well as instructions for developers who want to contribute to STACK.

## Contributing to STACK

STACK is open source, and as such relies on users to make contributions. These documents describe some ways you may consider to contribute.

You may want to learn about [creating an input type](Creating_an_input_type.md).

You could read about [Installing language pack and translating STACK](Language_packs.md).

There is also information on [contributing to the documentation](Documentation.md).

## Development history

If you want to track the development of STACK or report bugs then you should visit [GitHub](https://github.com/maths/moodle-qtype_stack).

Work towards the next release of STACK is detailed on [Development track](Development_track.md).

Plans looking futher into the future are described on [Future plans](Future_plans.md).

The past development history is documented on [Development history](Development_history.md).

## Advanced topics

The following topics describe advanced topics for developers and site admins.

You can read about running [unit tests](Unit_tests.md).

There is information on [clearing the cache](Question_state_caching.md).

You can also read on [adding support for Maxima packages](Maxima_packages.md).

If you have recently upgraded from an older STACK version, you may need to [upgrade question defaults](UpgradeDefaults.md).

You may want to know how to [run question tests on a development server](Running_question_tests_other_site.md) before upgrading to a new version of STACK.

You can read about the design of the [PHP interface to the CAS](PHP-CAS.md).