define ("qtype_stack/input",["core/ajax","core/event"],function(Ajax,CustomEvents){"use strict";function StackInput(validationDiv,prefix,qaid,name,input){var TYPING_DELAY=1e3,delayTimeoutHandle=null,validationResults={},lastValidatedValue=getInputValue();function cancelTypingDelay(){if(delayTimeoutHandle){clearTimeout(delayTimeoutHandle)}delayTimeoutHandle=null}input.addEventHandlers(valueChanging);function valueChanging(){cancelTypingDelay();showWaiting();delayTimeoutHandle=setTimeout(valueChanged,1000);setTimeout(function(){checkNoChange()},0)}function checkNoChange(){if(getInputValue()===lastValidatedValue){cancelTypingDelay();validationDiv.classList.remove("waiting")}}function valueChanged(){cancelTypingDelay();if(!showValidationResults()){validateInput()}}function validateInput(){Ajax.call([{methodname:"qtype_stack_validate_input",args:{qaid:qaid,name:name,input:getInputValue()},done:function done(a){validationReceived(a)},fail:function fail(a){showValidationFailure(a)}}]);showLoading()}function getInputValue(){return input.getValue()}function validationReceived(a){if("invalid"===a.status){showValidationFailure(a);return}validationResults[a.input]=a;showValidationResults()}function extractScripts(a,b){var c=/<script[^>]*>([\s\S]*?)<\/script>/g,d;while(null!==(d=c.exec(a))){b.push(d[1])}return a.replace(c,"")}function showValidationResults(){var val=getInputValue();if(!validationResults[val]){showWaiting();return!1}var results=validationResults[val];lastValidatedValue=val;var scriptCommands=[];validationDiv.innerHTML=extractScripts(results.message,scriptCommands);for(var i=0;i<scriptCommands.length;i++){eval(scriptCommands[i])}removeAllClasses();if(!results.message){validationDiv.classList.add("empty")}CustomEvents.notifyFilterContentUpdated(validationDiv);return!0}function showValidationFailure(a){lastValidatedValue="";validationDiv.innerHTML=a.message;removeAllClasses();validationDiv.classList.add("error");CustomEvents.notifyFilterContentUpdated(validationDiv)}function showLoading(){removeAllClasses();validationDiv.classList.add("loading")}function showWaiting(){removeAllClasses();validationDiv.classList.add("waiting")}function removeAllClasses(){validationDiv.classList.remove("empty");validationDiv.classList.remove("error");validationDiv.classList.remove("loading");validationDiv.classList.remove("waiting")}}function StackSimpleInput(a){this.addEventHandlers=function(b){a.addEventListener("input",b)};this.getValue=function(){return a.value.replace(/^\s+|\s+$/g,"")}}function StackTextareaInput(a){this.addEventHandlers=function(b){a.addEventListener("input",b)};this.getValue=function(){var b=a.value.replace(/^\s+|\s+$/g,"");return b.split(/\s*[\r\n]\s*/).join("<br>")}}function StackRadioInput(a){this.addEventHandlers=function(b){a.addEventListener("input",b)};this.getValue=function(){var b=a.querySelector(":checked");if(b){return b.value}else{return""}}}function StackCheckboxInput(a){this.addEventHandlers=function(b){a.addEventListener("input",b)};this.getValue=function(){for(var b=a.querySelectorAll(":checked"),c=[],d=0;d<b.length;d++){c[d]=b[d].value}if(0<c.length){return c.join(",")}else{return""}}}function StackMatrixInput(a,b){var c=0,d=0;b.querySelectorAll("input[type=text]").forEach(function(b){if(b.name.slice(0,a.length+5)!==a+"_sub_"){return}var e=b.name.substring(a.length+5).split("_");d=Math.max(d,parseInt(e[0],10)+1);c=Math.max(c,parseInt(e[1],10)+1)});this.addEventHandlers=function(a){b.addEventListener("input",a)};this.getValue=function(){for(var e=Array(d),f=0;f<d;f++){e[f]=Array(c)}b.querySelectorAll("input[type=text]").forEach(function(b){if(b.name.slice(0,a.length+5)!==a+"_sub_"){return}var c=b.name.substring(a.length+5).split("_");e[c[0]][c[1]]=b.value.replace(/^\s+|\s+$/g,"")});return"matrix(["+e.join("],[")+"])"}}function initInputs(a,b,c,d){for(var e=document.getElementById(a),f=!0,g=0;g<d.length;g++){f=initInput(e,b,c,d[g])&&f}if(f&&(e.classList.contains("dfexplicitvaildate")||e.classList.contains("dfcbmexplicitvaildate"))){e.querySelector(".im-controls input.submit").hidden=!0}}function initInput(a,b,c,d){var e=document.getElementById(b+d+"_val");if(!e){return!1}var f=getInputTypeHandler(a,b,d);if(f){new StackInput(e,b,c,d,f);return!0}else{return!1}}function getInputTypeHandler(a,b,c){var d=a.querySelector("[name=\""+b+c+"\"]");if(d){if("TEXTAREA"===d.nodeName){return new StackTextareaInput(d)}else if("radio"===d.type){return new StackRadioInput(d.closest(".answer"))}else{return new StackSimpleInput(d)}}d=a.querySelector("[name=\""+b+c+"_1\"]");if(d&&"checkbox"===d.type){return new StackCheckboxInput(d.closest(".answer"))}var e=document.getElementById(b+c+"_container");if(e){return new StackMatrixInput(b+c,e)}return null}return{initInputs:initInputs}});
//# sourceMappingURL=input.min.js.map
